<?php

namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Teknisa\CRM\Service\MauticService;

use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;



class MauticController
{
    protected $MauticService;

    public function __construct(MauticService $MauticService)
    {
        $this->MauticService = $MauticService;
    }

    public function saveParamMautic(Row $request, Response $response) {
        header("Access-Control-Allow-Origin: *");
        header("Access-Control-Allow-Credentials: true");
        header("Access-Control-Allow-Methods: GET, HEAD, OPTIONS, POST, PUT");
        header("Access-Control-Allow-Headers: Content-Type");
        
        $row = $request->getRow();
        
        try {
            $this->MauticService->saveParamMautic($row);
            
            $returnArray = array(
                "AUTHENTICATED" => "success"
            );
            
            $response->addDataSet(new DataSet("DADOS", $returnArray));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function getLeads(Request $request, Response $response)
    {
        $returnArray = [$this->MauticService->getLeads()];
        $response->addDataSet(new DataSet("DADOS", $returnArray));
    }

    public function getCompanies(Request $request, Response $response)
    {
        $returnArray = [$this->MauticService->getCompanies()];
        $response->addDataSet(new DataSet("DADOS", $returnArray));
    }

    /*
    --------------------------------------------------
    | 
    | Configuraçao Integraçao
    | Sentido: Mautic -> CRM
    |
    --------------------------------------------------
    */
    public function handleWebhook(Request $request, Response $response)
    {
        
        header('Content-Type: application/json');
        
        $jsonPayload = $request->getParameters();
        
        $webhookData = $jsonPayload;
        
        if (json_last_error() !== JSON_ERROR_NONE) {
            http_response_code(400); 
            echo json_encode(['status' => 400, 'message' => 'Payload inválido']);
            return; 
        }

        if (isset($webhookData['mautic.company_post_save'])) {
            $newCompany = $webhookData['mautic.company_post_save'];
            $this->MauticService->saveProspect($newCompany);
        }

        //Se o evento recebido for de criaçao de um novo contato:
        if (isset($webhookData['mautic.lead_company_change'])) {
            $newLeadData = $webhookData['mautic.lead_company_change'];
            $this->MauticService->novoInterlocutor($newLeadData);
        }

        //Se o evento recebido for de edição de contato:
            if (isset($webhookData['mautic.lead_post_save_update'])) {
                $newLeadData = $webhookData['mautic.lead_post_save_update'];
                $this->MauticService->novoInterlocutor($newLeadData);
            }

    }
}
